#include <bits/stdc++.h>

using namespace std;

bool mat[600][600];
int main () {
  ios::sync_with_stdio(false);
  cin.tie(0);
  int n, m;
  cin >> n >> m;
  vector<vector<int>> g(n, vector<int>(m));
  vector<bool> used;
  int roods_a[m], roods_b[m];
  for (int i = 0; i < m; ++i) {
    int a, b;
    cin >> a >> b;
    --a, --b;
    mat[a][b] = mat[b][a] = 1;
    g[a].push_back(b);
    g[b].push_back(a);
    roods_a[i] = a, roods_b[i] = b;
  }
  int a, b;
  int ans = 0;
  function <void(int)> dfs = [&] (int x) {
    //cout << x << ' ';
    used[x] = 1;
    if (x == b) return;
    for (int i: g[x]) {
      if (!used[i] && mat[x][i] == true) {
        dfs(i);
      }
    }
  };
  //cout << ans << '\n';
  for (int i = 0; i < m; ++i) {
    used.assign(n, false);
    a = roods_a[i];
    b = roods_b[i];
    //cout << a << ' ' << b << ' ';
    mat[a][b] = mat[b][a] = 0;
    dfs(a);
    mat[a][b] = mat[b][a] = 1;
    ans += (used[b] ? 0 : 1);
    //cout << "                 " << used[b] << ' ';
    //cout << ans << '\n';
  }
  cout << ans << '\n';
}
