#include "bits/stdc++.h"

using namespace std;
vector<vector<int>> g;
vector<int> t;
vector<int> p;
int T = 0;
vector<bool> used;
int ans = 0;

void dfs(int v, int u) {
    used[v] = true;
    t[v] = p[v] = T++;
    for (auto w:g[v]) {
        if (w == u)
            continue;
        if (used[w]) {
            t[v] = min(t[v], p[w]);
        } else {
            dfs(w, v);
            if (p[v] < t[w]) {
                ++ans;
            }
            t[v] = min(t[v], t[w]);
        }
    }
}

void solve() {
    int n, m;
    cin >> n >> m;
    g.resize(n);
    t.resize(n);
    p.resize(n);
    used.resize(n);
    for (int i = 0; i < m; ++i) {
        int a, b;
        cin >> a >> b;
        --a, --b;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    for (int i = 0; i < n; ++i)
        if (!used[i])
            dfs(i, -1);
    cout << ans << '\n';
}

int main() {
    solve();
}