#include <bits/stdc++.h>

//#define int long long
#define ff first
#define ss second
#define pb push_back

using namespace std;

const int N = 2e5 + 5, inf = 1e18 + 100;

struct edge
{
    int u, v;
}e[2005];

map < pair < int, int >, int > id;
int boss[605], sz[605];

int get_num(int x)
{
    if (boss[x] == x) return x;
    return boss[x] = get_num(boss[x]);
}

void unite(int u, int v)
{
    int x = get_num(u);
    int y = get_num(v);

    if (x != y)
    {
        if (sz[x] < sz[y]) boss[x] = y, sz[y] += sz[x];
        else boss[y] = x, sz[x] += sz[y];
    }
}

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie();
    int n, m;
    cin >> n >> m;
    for (int i = 1; i <= m; ++i)
    {
        cin >> e[i].u >> e[i].v;

        id[{e[i].u, e[i].v}] = i;
        id[{e[i].v, e[i].u}] = i;
    }

    int cnt = 0;
    for (int i = 1; i <= n; ++i)
    {
        for (int j = i + 1; j <= n; ++j)
        {
            for (int l = 1; l <= n; ++l)
                boss[l] = l, sz[l] = 1;

            int ed = id[{i, j}];
            if (!ed) continue;

            for (int k = 1; k <= m; ++k)
            {
                if (ed == k) continue;
                unite(e[k].u, e[k].v);
            }

            for (int l = 1; l <= n; ++l)
                int x = get_num(l);

            cnt += (boss[i] != boss[j]);
        }
    }

    cout << cnt;
    return 0;
}
