#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <set>
#include <cmath>
#include <random>
#include <ctime>
#define int long long
using namespace std;
void dfs(int now, int prev, vector<bool> &was, vector<vector<int>> &graf, int v, int u){
    if (was[now])
        return;
    was[now] = true;
    for (int i = 0; i < graf[now].size(); i++){
        if (graf[now][i]!=prev && (graf[now][i]!=v || now!=u) && (graf[now][i]!=u || now!=v))
            dfs(graf[now][i], now, was, graf, v, u);
    }
}
signed main() {
    ios::sync_with_stdio(false);
    int n, m, c = 0;
    cin >> n >> m;
    vector<vector<int>> graf(n, (vector<int>){});
    vector<pair<int, int>> reb(m);
    for (int i = 0; i < m; i++) {
        cin >> reb[i].first >> reb[i].second;
        reb[i].first--;
        reb[i].second--;
        graf[reb[i].first].push_back(reb[i].second);
        graf[reb[i].second].push_back(reb[i].first);
    }
    for (int i = 0; i < m; i++){
        vector<bool> was1(n, false);
        vector<bool> was2(n, false);
        bool check = true;
        dfs(reb[i].first, -1, was2, graf, -1, -1);
        dfs(reb[i].first, -1, was1, graf, reb[i].first, reb[i].second);
        if (was1 != was2)
            c++;
    }
    cout << c;
}
