#include <bits/stdc++.h>
using namespace std;
typedef long long ll;

struct node{
    vector<int> edges;
    bool used;
};

vector<node> arr;

bool cmp(pair<int, int> p, int a, int b){
    return (p.first == a && p.second == b) || (p.first == b && p.first == a);
}

void dfs(int v, pair<int, int> banned_edge){
    arr[v].used = true;
    for(int u : arr[v].edges){
        if(!arr[u].used && !cmp(banned_edge, u, v) && !cmp(banned_edge, v, u)){
            dfs(u, banned_edge);
        }
    }
}

signed main(){
    int n, m;
    cin >> n >> m;
    arr.resize(n);
    for(int i = 0; i < n; i++){
        arr[i].used = false;
    }
    vector<pair<int, int>> edges;
    while(m--){
        int u, v;
        cin >> u >> v;
        u--, v--;
        arr[u].edges.push_back(v);
        arr[v].edges.push_back(u);
        edges.push_back({u, v});
    }
    int cnt = 0;
    for(int i = 0; i < n; i++){
        if(!arr[i].used){
            cnt++;
            dfs(i, {-1, -1});
        }
    }
    int ans = 0;
    for(auto e : edges){
        for(int i = 0; i < n; i++){
            arr[i].used = false;
        }
        int cnt_ = 0;
        for(int i = 0; i < n; i++){
            if(!arr[i].used){
                cnt_++;
                dfs(i, e);
            }
        }
        if(cnt != cnt_){
            ans++;
        }
    }
    cout << ans;
}
