#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>

using namespace std;

const int N = 1e3;

vector < vector <int> > g(N, vector <int> ());
vector <int> used(N, 0), d(N, 0), up(N, 0);
int an = 0;

void dfs(int v, int p, int l) {
    d[v] = l; up[v] = l;
    used[v] = 1;
    for (auto u : g[v]) {
        if (!used[u]) {
            dfs(u, v, l + 1);
            if (up[u] > d[v]) {
                an++;
            }
            up[v] = min(up[v], up[u]);
        } else {
            if (u != p) {
                up[v] = min(up[v], d[u]);
            }
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    int n, m; cin >> n >> m;
    for (int i = 0; i < m; ++i) {
        int u, v; cin >> u >> v;
        u--; v--;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    dfs(0, -1, 0);
    cout << an << "\n";
    return 0;
}
