#include <iostream>
#include <algorithm>
#include <vector>
#pragma comment(linker, "/stack:200000000")
#pragma GCC optimize("Ofast,no-stack-protector")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,tune=native")
#pragma GCC optimize("unroll-loops")

using namespace std;

signed main() {
    ios_base::sync_with_stdio(0);
    int k; cin >> k;
    int s[k];
    int n = 0;
    vector < vector <int> > a(k, vector <int> ());
    for (int i = 0; i < k; ++i) {
        cin >> s[i];
        a[i].resize(s[i]);
        n += s[i];
    }
    vector <int> all(n);
    int ind = 0;
    for (int i = 0; i < k; ++i) {
        for (int j = 0; j < s[i]; ++j) {
            cin >> a[i][j];
            all[ind] = a[i][j];
            ind++;
        }
    }
    stable_sort(all.begin(), all.end());
    vector <int> l(n, 0);
    for (int i = 0; i < k; ++i) {
        for (int j = 0; j < s[i]; ++j) {
            a[i][j] = lower_bound(all.begin(), all.end(), a[i][j]) - all.begin();
            if (l[a[i][j]] == i) {
                l[a[i][j]]++;
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        if (l[i] == k) {
            cout << all[i] << "\n";
            return 0;
        }
    }
    cout << "x\n";
    return 0;
}
