#include <iostream>
#include <vector>
#include <queue>
#include <algorithm>

using namespace std;

int n,m,out=0;

bool ok(vector<int> g[]){
	bool viseted[n];
	for(int i=0;i<n;i++){
		viseted[i]=false;
	}
	queue<int> mq;
	mq.push(0);
	int curr;
	while(!mq.empty()){
		curr=mq.front();
		mq.pop();
		viseted[curr]=true;
		for(int i=0;i<g[curr].size();i++){
			if(!viseted[g[curr][i]]){
				mq.push(g[curr][i]);
			}
		}
	}
	for(int i=0;i<n;i++){
		if(viseted[i]==false){
			return false;
		}
	}
	return true;
}

int main(){
	cin>>n>>m;
	vector<int> G[n];
	vector<int> tG[n];
	int a[m],b[m];
	for(int i=0;i<m;i++){
		cin>>a[i]>>b[i];
		a[i]--;b[i]--;
		G[a[i]].push_back(b[i]);
		G[b[i]].push_back(a[i]);
	}
	for(int i=0;i<m;i++){
		for(int j=0;j<n;j++){
			tG[j]=G[j];
		}
		tG[a[i]].erase(remove(tG[a[i]].begin(), tG[a[i]].end(), b[i]), tG[a[i]].end());
		tG[b[i]].erase(remove(tG[b[i]].begin(), tG[b[i]].end(), a[i]), tG[b[i]].end());
		if(!ok(tG)){
			out++;
		}
	}
	cout<<out<<endl;
	return 0;
}
