#include <bits/stdc++.h>
//#include "guess.h"

#pragma GCC optimize ("Ofast")

#define ll long long
#define pb push_back
#define F first
#define S second
#define ld long double

using namespace std;

const int N = 6e3 + 21;

const int rx[] = {1, -1, 1, -1, 2, -2, 2, -2};
const int ry[] = {2, -2, -2, 2, 1, -1, -1, 1};

vector <int> g[N];
pair <int, int> pp;
vector <bool> used;

void dfs(int v) {
    used[v] = 1;
    for(auto to: g[v]) {
        if(pp.F == v && pp.S == to) continue;
        if(pp.F == to && pp.S == v) continue;
        if(used[to]) continue;
        dfs(to);
    }
}

main() {
    ios_base::sync_with_stdio();
    cin.tie(0);
    cout.tie(0);
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // LOCAL
    int n, m;
    cin >> n >> m;
    pair <int, int> p[m];
    for(int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        u --, v --;
        p[i].F = u;
        p[i].S = v;
        g[v].pb(u);
        g[u].pb(v);
    }
    int ans = 0;
    for(int i = 0; i < m; ++i) {
        pp.F = p[i].F;
        pp.S = p[i].S;
        used.clear();
        used.resize(n, 0);
        dfs(0);
        bool ok = 1;
        for(int j = 0; j < n; ++j) if(!used[j]) ok = 0;
        if(!ok) ans ++;
    }
    cout << ans << endl;
}
