#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <iomanip>
#include <assert.h>
#include <string>
#include <cmath>

using namespace std;
typedef long long ll;
typedef long double ld;
int n;
vector <int> a[1010];
vector <int> b[1010];

bool in(const vector <int>& a, int v)
{
	auto got = lower_bound(a.begin(), a.end(), v);
	if (got == a.end()) return false;
	return *got == v;
}

signed main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);

	cin >> n;

	for (int i = 1; i <= n; ++i)
	{
		int s;
		cin >> s;
		a[i].resize(s);
	}

	for (int i = 1; i <= n; ++i)
	{
		for (int j = 0; j < a[i].size(); ++j)
		{
			cin >> a[i][j];
		}
		sort(a[i].begin(), a[i].end());
		a[i].resize(unique(a[i].begin(), a[i].end()) - a[i].begin());
	}

	b[1] = a[1];

	for (int i = 2; i <= n; ++i)
	{
		for (auto j : a[i])
		{
			if (in(b[i - 1], j)) b[i].push_back(j);
		}
	}

	if (b[n].size())
	{
		cout << b[n][0];
	}
	else
	{
		cout << 'x';
	}
	return 0;
}