#include <bits/stdc++.h>

using namespace std;

void SetIO() {
#ifdef BLAT
    freopen("ban.in", "r", stdin);
    freopen("ban.out", "w", stdout);
#endif // BLAT
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);
}

const int N = 600;
const int M = 2000;

pair <int, int> e[1 + M];
vector <int> G[1 + N];

bool viz[1 + N];

void DFS(int node) {
    viz[node] = true;
    for(int to : G[node])
        if(!viz[to]) DFS(to);
}

bool Access(int n) {
    memset(viz, 0, sizeof(viz));

    DFS(1);
    for(int i = 1; i <= n; i++)
        if(!viz[i]) return false;

    return true;
}

int main() {
    SetIO();
    int n, m, ban(0);
    cin >> n >> m;

    for(int i = 1; i <= m; i++)
        cin >> e[i].first >> e[i].second;

    for(int i = 1; i <= m; i++) {
        for(int j = 1; j <= n; j++) G[j].clear();

        for(int j = 1; j <= m; j++) {
            if(i != j) {
                G[e[j].first].push_back(e[j].second);
                G[e[j].second].push_back(e[j].first);
            }
        }

        if(Access(n) == false)
            ++ban;
    }

    cout << ban << '\n';
    return 0;
}
