#include <bits/stdc++.h>
#define endl "\n"
using namespace std;
typedef long long ll;
mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

const int N = 606;
set<int> g[N];
bool vis[N];
int c = 0;

void dfs(int v){
  vis[v] = true;
  c ++;
  for(int x: g[v])
    if(!vis[x])
      dfs(x);
}

int main(){
  ios_base::sync_with_stdio(0);
  cin.tie(0); cout.tie(0);
  int n, m;
  cin >> n >> m;
  vector<pair<int, int>> edge(m);
  for(int i = 0; i < m; i ++){
    int u, v;
    cin >> u >> v;
    u --; v --;
    g[u].insert(v);
    g[v].insert(u);
    edge[i] = {u, v};
  }
  int ans = 0;
  for(int i = 0; i < m; i ++){
    auto [u, v] = edge[i];
    g[u].erase(v);
    g[v].erase(u);
    for(int i = 0; i < n; i ++)
      vis[i] = false;
    c = 0;
    dfs(u);
    if(c != n)
      ans ++;
    g[u].insert(v);
    g[v].insert(u);
  }
  cout << ans;
}

