#include <bits/stdc++.h>

using std::cin;
using std::cout;
using std::cerr;
using std::vector;
using std::string;
using std::pair;

using ll = long long;
using ld = long double;


vector<vector<int>> g;
vector<int> tin, up;
int ans = 0;

void dfs (int u, int p = -1) {
	static int t = 1;
	tin[u] = up[u] = t++;
	for (int v : g[u]) {
		if (v != p && tin[v] != 0) {
			up[u] = std::min(up[u], tin[v]);
		} else if (v != p) {
			dfs(v, u);
			up[u] = std::min(up[u], up[v]);
			if (up[v] > tin[u])
				++ans;
		}
	}
}


int main() {
	std::ios_base::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);

	int n, m;
	cin >> n >> m;

	g.resize(n);
	tin.resize(n);
	up.resize(n);

	for (int i = 0; i < m; ++i) {
		int u, v;
		cin >> u >> v;
		--u, --v;
		g[u].push_back(v);
		g[v].push_back(u);
	}

	for (int i = 0; i < n; ++i)
		if (tin[i] == 0)
			dfs(i);

	cout << ans;


	return 0;
}