#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <math.h>
using namespace std;
int ans=0;
int n,m;
vector<pair<int,int> > roads(2000);
vector<vector<int> > a(600,vector<int> (600,0));

vector<bool> dfs(int cur,vector<bool> used)
{
    for(int i=0; i<n; ++i)
    {
        if(a[i][cur] && !used[i])
        {
            used[i]=true;
            used=dfs(i,used);
        }
    }
    return used;
}
int main()
{
    cin>>n>>m;
    vector<bool> used(n,false);
    used[0]=true;
    for(int i=0; i<m; ++i)
    {
        cin>>roads[i].first>>roads[i].second;
        roads[i].first--,roads[i].second--;
        a[roads[i].first][roads[i].second]++;
        a[roads[i].second][roads[i].first]++;
    }
    for(int i=0; i<m; ++i)
    {
        a[roads[i].first][roads[i].second]--;
        a[roads[i].second][roads[i].first]--;
        vector<bool> cur=dfs(0,used);
        for(int j=0; j<n; ++j)
        {
            if(!cur[j])
            {
                ans++;
                break;
            }
        }
        a[roads[i].first][roads[i].second]++;
        a[roads[i].second][roads[i].first]++;
    }
    cout<<ans<<endl;
    return 0;
}
