#include <iostream>
#include <vector>

using namespace std;

const int NMAX = 600;
const int MMAX = 2000;
int a[MMAX + 1], b[MMAX + 1];
bool viz[NMAX + 1];
vector <int> v[NMAX + 1];

int cnt, ban_nod, ban_next_nod;

void dfs( int nod ){
  viz[nod] = 1; ++cnt;
  for( int i = 0; i < v[nod].size(); ++i )
    if( !viz[v[nod][i]] && nod != ban_nod && v[nod][i] != ban_next_nod )
      dfs(v[nod][i]);
}

int main() {
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  cout.tie(0);
  int n, m, i, j, sol;
  cin >> n >> m;
  for( i = 0; i < m; ++i ){
    cin >> a[i] >> b[i];
    v[a[i]].push_back(b[i]);
    v[b[i]].push_back(a[i]);
  }
  sol = 0;
  for( i = 0; i < m; ++i ){
    ban_nod = a[i];
    ban_next_nod = b[i];
    cnt = 0;
    dfs(1);
    if( cnt < n )
      ++sol;
  }
  cout << m - sol;
  return 0;
}
