﻿#include <iostream>
#include <vector>
#include <algorithm>
#include <numeric>
#include <functional>


constexpr int MAXN = 6e2 + 5;



std::vector<short> gr[MAXN];
short n, m, depth[MAXN], ans;



void dfs(short i, short d, short f) {
	if (depth[i] != -1) {
		return;
	}
	depth[i] = d;
	short x = d;
	for (short t : gr[i]) {
		if (depth[t] == -1) {
			dfs(t, d + 1, i);
			if (depth[t] > d) {
				ans++;
			}
		}
		if (t != f) {
			x = std::min(x, depth[t]);
		}
		
	}
	depth[i] = x;
}



int32_t main() {
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(0);
	std::cout.tie(0);

	std::cin >> n >> m;
	for (int i = 0; i < m; i++) {
		int u, v;
		std::cin >> u >> v;
		u--; v--;
		gr[u].push_back(v);
		gr[v].push_back(u);
	}

	std::fill(depth, depth + n, -1);
	for (int i = 0; i < n; i++) {
		dfs(i, 0, -1);
	}

	std::cout << ans << '\n';

	std::cout.flush();
	return 0;
}