#include <bits/stdc++.h>

struct Edge{
    int to;
    Edge *next;
};

Edge edges[666][666];
Edge *last_edge[666];

void add_edge(int u, int v) {
    edges[u][v] = {v, last_edge[u]};
    last_edge[u] = &edges[u][v];
    
    edges[v][u] = {u, last_edge[v]};
    last_edge[v] = &edges[v][u];
}

int used[666];
int vis;

int n, m;

int bfs(Edge *bad1, Edge *bad2) {
    int vis = 0;
    memset(used, 0, 666*sizeof(int));
    std::queue<int> q;
    q.push(1);
    while (!q.empty()) {
	int cn = q.front();
	q.pop();
	if (used[cn]) continue;;
	used[cn] = true;
	vis++;
	Edge *ce = last_edge[cn];
	while (ce) {
	    if (ce != bad1 && ce != bad2)
		q.push(ce->to);
	    ce = ce->next;
	}
    }
    return vis;
}

int inputs[1000][2];

int main() {
    scanf("%d%d", &n, &m);
    for (int i = 0; i < m; i++) {
	int u, v;
	scanf("%d%d", &u, &v);
	add_edge(u, v);
	inputs[i][0] = u;
	inputs[i][1] = v;
    }

    int ans = 0;
    for (int i = 0; i < m; i++) {
	int u = inputs[i][0];
	int v = inputs[i][1];
	Edge *bad1 = &edges[u][v];
	Edge *bad2 = &edges[v][u];
	if (bfs(bad1, bad2) < n) ans++;
    }
    printf("%d\n", ans);
}
