#include <iostream>
using namespace std;
#define endl '\n'
const int MAXN=6e2+10;
const int MAXM=2e3+10;
int a[MAXM], b[MAXM];
bool ed[MAXN][MAXN];
bool used[MAXN];
int n, m;
void dfs(int x) {
    used[x]=true;
    for (int i=1;i<=n;i++) {
        if (ed[i][x] && !used[i]) dfs(i);
    }
}
int main () {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cin >> n >> m;
    for (int i=0;i<m;i++) {
        cin >> a[i] >> b[i];
        ed[a[i]][b[i]]=ed[b[i]][a[i]]=true;
    }
    int ans=0;
    for (int i=0;i<m;i++) {
        ed[a[i]][b[i]]=ed[b[i]][a[i]]=false;
        dfs(a[i]);
        if (!used[b[i]]) ans++;
        ed[a[i]][b[i]]=ed[b[i]][a[i]]=true;
        for (int j=1;j<=n;j++) used[j]=false;
    }
    cout << ans << endl;
    return 0;
}
