#include <bits/stdc++.h>
using namespace std;

const int N = 666;

int n, m;
vector<pair<int, int>> g[N];
bool used[N];

void dfs(int v, int ban = -1){
    used[v] = 1;
    for(auto [u, i] : g[v]){
        if(i == ban) continue;
        if(!used[u]){
            dfs(u, ban);
        }
    }
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    ios::sync_with_stdio(false);
    cin.tie(0);
    cin >> n >> m;
    vector<pair<int, int>> e;
    for(int i = 0; i < m; i++){
        int a, b;
        cin >> a >> b;
        g[a].push_back({b, i});
        g[b].push_back({a, i});
        e.push_back({a, b});
    }
    int ans = 0;
    for(int i = 0; i < e.size(); i++){
        for(int j = 1; j <= n; j++) used[j] = 0;
        auto [a, b] = e[i];
        dfs(a, i);
        if(!used[b]) ans++;
    }
    cout << ans;
    return 0;
}

