#include <bits/stdc++.h>
 
using namespace std;
 
int main () {
  ios::sync_with_stdio(false);
  cin.tie(0);
  int n, m;
  cin >> n >> m;
  vector<vector<int>> g(n, vector<int>(m));
  vector<vector<bool>> mat(n, vector<bool>(m, false));
  vector<bool> used;
  vector<pair<int,int>> roods;
  for (int i = 0; i < m; ++i) {
    int a, b;
    cin >> a >> b;
    --a, --b;
    mat[a][b] = mat[b][a] = 1;
    g[a].push_back(b);
    g[b].push_back(a);
    roods.emplace_back(a, b);
  }
  int a, b;
  int ans = 0;
  function <void(int)> dfs = [&] (int x) {
    //cout << x << ' ';
    used[x] = 1;
    for (int i: g[x]) {
      if (!used[i] and mat[x][i]) {
        used[i] = 1;
        dfs(i);
      }
    }
  };
  //cout << ans << '\n';
  for (int i = 0; i < m; ++i) {
    used.assign(n, false);
    a = roods[i].first;
    b = roods[i].second;
    //cout << a << ' ' << b << ' ';
    mat[a][b] = mat[b][a] = 0;
    dfs(a);
    mat[a][b] = mat[b][a] = 1;
    ans += (used[b] ? 0 : 1);
    //cout << "                 " << used[b] << ' ';
    //cout << ans << '\n';
  }
  cout << ans << '\n';
}