#include <bits/stdc++.h>

using namespace std;
#define int long long

vector<set<int> > gr;
vector<bool> used;

void dfs(int v, int pr = -1) {
    used[v] = true;
    for(auto u : gr[v])
        if(!used[u])
            dfs(u, v);
}

signed main() {
    int n, m;
    cin >> n >> m;
    gr.resize(n);
    used.resize(n);
    vector<pair<int, int> > all(m);
    for (int i = 0; i < m; ++i) {
        int x, y;
        cin >> x >> y;
        --x;
        --y;
        all[i] = {x, y};
        gr[x].insert(y);
        gr[y].insert(x);
    }
    int cnt = 0;
    for (int i = 0; i < m; ++i) {
        fill(used.begin(), used.end(), false);
        gr[all[i].first].erase(all[i].second);
        gr[all[i].second].erase(all[i].first);
        dfs(all[i].first);
        if (!used[all[i].second])
            cnt++;

        gr[all[i].first].insert(all[i].second);
        gr[all[i].second].insert(all[i].first);

    }
    cout << cnt;
}