#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>

#define int long long

using namespace std;

vector < int > sz, cnt;
vector < vector < int > > a;
set < pair < int, int > > st;


main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int k;
    cin >> k;
    if(k == 0)
    {
        cout << 'x';
        return 0;
    }
    sz.resize(k);
    a.resize(k);
    cnt.resize(k);
    for(int i = 0; i < k; i++)
    {
        cin >> sz[i];
        a[i].resize(sz[i]);
    }
    for(int i = 0; i < k; i++)
    {
        for(int j = 0; j < sz[i]; j++)
            cin >> a[i][j];
        sort(a[i].begin(), a[i].end());
        st.insert({a[i][0], i});
    }
    while(true)
    {
        int x = (*st.begin()).first;
        int y = (*st.begin()).second;
        if(x == (*st.rbegin()).first)
        {
            cout << x;
            return 0;
        }
        cnt[y]++;
        if(cnt[y] == sz[y])
        {
            cout << 'x';
            return 0;
        }
        st.erase(st.begin());
        st.insert({a[y][cnt[y]], y});
    }
    return 0;
}
