#include <iostream>
#include <vector>
#include <queue>

using namespace std;
const int nmax=605;
const int mmax=2005;
struct muchie
{
    int x,y;
};
muchie edge[nmax];
int n,m;
vector <int > G[nmax];
bool marker[nmax];
int node(muchie b,int a)
{
    if(b.x==a)return b.y;
    return b.x;
}
bool Ban(int ind)
{
    for(int i=1;i<=n;i++)
    {
        marker[i]=0;
    }
    queue < int > q;
    q.push(edge[ind].x);
    marker[edge[ind].x]=1;
    while(!q.empty())
    {
        int from=q.front();
        q.pop();
        for(auto it:G[from])
        {
            int spre=node(edge[it],from);
            if(it==ind)continue;
            if(!marker[spre])
               {
                   marker[spre]=1;
                   q.push(spre);
               }
        }
    }
    if(marker[edge[ind].y]==1)return 0;
    return 1;
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cin>>n>>m;
    for(int i=1;i<=m;i++)
    {
        int x,y;
        cin>>x>>y;
        edge[i]={x,y};
        G[x].push_back(i);
        G[y].push_back(i);
    }
    int ans=0;
    for(int i=1;i<=m;i++)
    {
        bool ok=Ban(i);
        ans+=ok;
    }
    cout<<ans<<'\n';
    return 0;
}
