#include <fstream>
#include <iostream>
#include <vector>
#include <set>
#include <list> 
#include <map>
#include <queue>
#include <deque>
#include <string>
#include <stack>
#include <algorithm>
#include <utility>
#include <math.h>
#include <ctime>

using namespace std;
typedef long long int63;
typedef unsigned long long int64;
#define forl(name,start,end,jump) for(int63 name = start; name < end; name+=jump)
#define forlb(name,start,end,jump) for(int63 name = end - 1; name >= start; name+=jump)
#define forn(name,start,end) forl(name,start,end,1)
#define fornb(name,start,end) forlb(name,start,end,-1)
#define fort(start,end) forn(i,start,end)
#define fortb(start,end) fornb(i,start,end)
#define forto(start,end) forn(j,start,end)
#define fortob(start,end) fornb(j,start,end)
#define fortoo(start,end) forn(l,start,end)
#define make(name) int63 name; cin >> name
#define all(name) name.begin(), name.end()
#define rall(name) name.rbegin(), name.rend()
#define point pair<int63,int63>
#define dpoint pair<double,double>

union superdat {
	int63 i;
	double d;
	vector<int63>vi;
	queue<int63>q;
	vector<point>vp;
	point p;
};

struct union_find {
	vector<int63>rot;
	vector<int63>powe;
	vector<vector<int63>> rat;
	int63 cnt;
	void init(int63 n) {
		fort(0, n) {
			rot.push_back(i);
			powe.push_back(0);
			rat.push_back({i});
		}
		cnt = n;
	}
	bool isunion(int63 f, int63 s) {
		if (rot[f] == rot[s]) {
			return true;
		}
		return false;
	}
	void empower(int63 f, int63 p) {
		powe[rot[f]] = max(powe[rot[f]], p);
	}
	bool unio(int63 f, int63 s) {
		if (rot[f] == rot[s]) {
			return false;
		}
		cnt--;
		//rot[f] <-> rot[s]
		if (rat[rot[f]].size() < rat[rot[s]].size()) {
			swap(f, s);
		}
		powe[rot[f]] = max(powe[rot[f]], powe[rot[s]]);
		int63 siz = rat[rot[s]].size();
		int63 rs = rot[s];
		fort(0, siz) {
			rat[rot[f]].push_back(rat[rs][i]);
			rot[rat[rs][i]] = rot[f];
		}
		rat[rs].clear();
		return true;
	}
	int63 cp(int f) {
		return powe[rot[f]];
	}
};

int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	make(n);
	int63 x;
	vector<int63> l(n);
	fort(0, n) {
		cin >> l[i];
	}
	vector<int63> d;
	set<int63> c;
	fort(0, l[0]) {
		cin >> x;
		c.insert(x);
	}
	forto(1, n) {
		d.clear();
		fort(0, l[j]) {
			cin >> x;
			d.push_back(x);
		}
		sort(all(d));
		int63 ex = 0;
		for(auto it = c.begin(); it != c.end();) {
			while (ex < d.size() && d[ex] < *it) {
				ex++;
			}
			auto oops = it;
			it++;
			if (ex >= d.size() || *oops != d[ex]) {
				c.erase(oops);
			}
		}
	}
	if (c.size()) {
		cout << *(c.begin()) << endl;
	} else {
		cout << 'x' << endl;
	}
	return 0;
}