#include <iostream>
#include <vector>
#include <bitset>

using namespace std;

const int N = 603;

vector < int > adia[N];
int uph[N], h[N];
bitset < N > viz;
int bans;

int Dfs(int nod, int t = 0) {
    uph[nod] = h[nod];
    bool ok(1);
    for (int i : adia[nod]) {
        if (i == t && ok == 1) {
            ok = 0;
            continue;
        }
        if (viz[i])
            uph[nod] = min(uph[nod], uph[i]);
        else {
            viz[i] = 1;
            h[i] = h[nod] + 1;
            Dfs(i, nod);
        }
        uph[nod] = min(uph[nod], uph[i]);
    }
    if (uph[nod] == h[nod] && t)
        ++bans;
}

int main()
{
    int n, m, a, b;
    cin >> n >> m;
    for (int i = 0; i < m; ++i) {
        cin >> a >> b;
        adia[a].push_back(b);
        adia[b].push_back(a);
    }
    for (int i = 1; i <= n; ++i) {
        if (!viz[i]) {
            viz[i] = 1;
            Dfs(i);
        }
    }
    cout << bans;
    return 0;
}
