#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

int bad = -1;

void dfs(int v, vector<vector<pair<int, int>>> &g, vector<bool> &used) {
    used[v] = true;
    for(auto& [u, i] : g[v]) {
        if (!used[u] && i != bad) {
            dfs(u, g, used);
        }
    }
}

int main() {
    int n, m;
    cin >> n >> m;
    vector<vector<pair<int, int>>> g(n);
    for(int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        --u; --v;
        g[u].push_back({v, i});
        g[v].push_back({u, i});
    }
    int ans = 0;
    for(int i = 0; i < m; ++i) {
        vector<bool> used(n, false);
        bad = i;
        dfs(0, g, used);
        if (count(used.begin(), used.end(), true) != n) {
            ++ans;
        }
    }
    cout << ans;
}
