#include <bits/stdc++.h>
using namespace std;
typedef long long ll;

struct node{
    vector<int> edges;
    bool used;
};

vector<node> arr;

bool cmp(pair<int, int> p, int a, int b){
    return (p.first == a && p.second == b) || (p.first == b && p.first == a);
}

int dfs(int v, pair<int, int> banned_edge){
    int ans = 1;
    arr[v].used = true;
    for(int u : arr[v].edges){
        if(!arr[u].used && !cmp(banned_edge, u, v) && !cmp(banned_edge, v, u)){
            ans += dfs(u, banned_edge);
        }
    }
    return ans;
}

signed main(){
    int n, m;
    cin >> n >> m;
    arr.resize(n);
    for(int i = 0; i < n; i++){
        arr[i].used = false;
    }
    vector<pair<int, int>> edges;
    while(m--){
        int u, v;
        cin >> u >> v;
        u--, v--;
        arr[u].edges.push_back(v);
        arr[v].edges.push_back(u);
        edges.push_back({u, v});
    }
    if(dfs(0, {-1, -1}) != n){
        return 1;
    } else {
        int ans = 0;
        for(auto e : edges){
            for(int i = 0; i < n; i++){
                arr[i].used = false;
            }
            if(dfs(0, e) != n){
                ans++;
            }
        }
        cout << ans;
    }
}
