#include <bits/stdc++.h>

using namespace std;

const int N_MAX = 602;
const int M_MAX = 2002;

int n, m;

int a[M_MAX], b[M_MAX];

struct Edge
{
    int u;
    int index;
};

vector <Edge> edges[N_MAX];

int closed;

bool visited[N_MAX];

int cnt;

void dfs (int u)
{
    visited[u] = true;
    for(int i = 0; i < (int)edges[u].size(); i++)
    {
        Edge e = edges[u][i];
        if(e.index != closed && visited[e.u] == false)
            dfs(e.u);
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> m;
    for(int i = 1; i <= m; i++)
    {
        int u, v;
        cin >> u >> v;
        a[i] = u;
        b[i] = v;
        edges[u].push_back(Edge{v, i});
        edges[v].push_back(Edge{u, i});
    }
    int ans = 0;
    for(int i = 1; i <= m; i++)
    {
        closed = i;
        for(int j = 1; j <= n; j++)
            visited[j] = false;
        dfs(a[closed]);
        if(visited[b[closed]] == false)
            ans++;
    }
    cout << ans << "\n";
    return 0;
}
