#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <iomanip>
#include <assert.h>
#include <string>
#include <cmath>

using namespace std;
typedef long long ll;
typedef long double ld;
int n, m;
vector <int> g[1000];
int timer;
int tin[1000], fup[1000];
bool used[1000];
int ans;

void dfs(int u, int p)
{
	assert(!used[u]);
	used[u] = true;
	tin[u] = fup[u] = timer++;

	for (auto v : g[u]) if (v != p)
	{
		if (used[v])
		{
			fup[u] = min(fup[u], tin[v]);
		}
		else
		{
			dfs(v, u);
			fup[u] = min(fup[u], fup[v]);
			if (fup[v] > tin[u])
			{
				++ans;
			}
		}
	}
}

signed main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);

	cin >> n >> m;

	for (int i = 1; i <= m; ++i)
	{
		int u, v;
		cin >> u >> v;

		g[u].push_back(v);
		g[v].push_back(u);
	}

	for (int i = 1; i <= n; ++i)
	{
		if (used[i]) continue;
		dfs(i, i);
	}

	cout << ans;
	return 0;
}