#include <bits/stdc++.h>
#include <vector>

using namespace std;

//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("fast-math")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,tune=native")

#define ios ios_base::sync_with_stdio(0);cout.tie(0);cin.tie(0);
#define int long long
#define len(a) (int)(a).size()
#define all(a) a.begin(),(a).end()

//int INF = 2e18;
//int mod = 20999003;
//int p = 31;
//vector<int> p_pow;
//
//int subhash(const vector<int>& h, int i, int j){ //hash massive starts from [0]
//    return (h[j + 1] - (h[i] * p_pow[j - i + 1] % mod) + mod) % mod;
//}
struct dsu{
    vector<int> p;
    vector<int> w;
    int c;
    explicit dsu(int a){
        c = a;
        p.resize(a+1);
        w.resize(a+1);
        for (int i = 0; i < a+1; ++i) {
            make_set(i);
        }
    }

    void make_set(int a){
        p[a] = a;
        w[a] = 1;
    }

    int find_set(int a){
        if(a == p[a])return a;
        return p[a] = find_set(p[a]);
    }

    void union_sets(int a, int b){
        a = find_set(a);
        b = find_set(b);
        if(a == b)return;
        if(w[b] > w[a])
            swap(a, b);
        w[a] += w[b];
        p[b] = a;
        --c;
    }
};

void solve() {
    int n, m;
    cin >> n >> m;
    vector<pair<int, int>> r(m);
    for (int i = 0; i < m; ++i) {
        cin >> r[i].first >> r[i].second;
    }
    int ans = 0;
    for (int i = 0; i < m; ++i) {
        dsu d(n);
        for (int j = 0; j < m; ++j) {
            if(j == i)continue;
            d.union_sets(r[j].first, r[j].second);
        }
        if(d.c > 1)++ans;
    }
    cout << ans << endl;
}

signed main() {
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
    ios;
    solve();
    return 0;
}