#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

vector<int> used;

void dfs(vector<vector<int>> &gr, int v, int not_v, int not_u) {
    used[v] = 1;
    for (auto u : gr[v]) {
        if (!(v == not_v && u == not_u) && !(v == not_u && u == not_v) && used[u] == 0) {
            dfs(gr, u, not_v, not_u);
        }
    }
}

signed main() {
    int n, m;
    cin >> n >> m;
    vector<vector<int>> gr(n);
    for (int i = 0; i < m; ++i) {
        int v, u;
        cin >> v >> u;
        gr[v - 1].push_back(u - 1);
        gr[u - 1].push_back(v - 1);
    }
    used.resize(n);
    int ans = 0;
    for (int i = 0; i < n; ++i) {
        if (used[i] == 0) {
            dfs(gr, i, -1, -1);
        }
    }
    vector<int> used1 = used;
    for (int i = 0; i < gr.size(); ++i) {
        for (int j = 0; j < gr[i].size(); ++j) {
            if (i < gr[i][j]) {
                fill(used.begin(), used.end(), 0);
                for (int i1 = 0; i1 < n; ++i1) {
                    if (used[i] == 0) {
                        dfs(gr, i1, i, gr[i][j]);
                    }
                }
                if (used != used1) {
                    ans += 1;
                }
            }
        }
    }
    cout << ans;
}
