#include <iostream>
#include <vector>
using namespace std;

#define ll long long
#define add push_back
#define fastio ios_base::sync_with_stdio(false); cin.tie(0);

const int N = 601;
const int M = 2001;
vector<int> g[N];
bool color[N][M];

void dfs(int s, int ind) {
	color[s][ind] = true;
	for (int i = 0; i < g[s].size(); i++) {
		if (g[s][i] != -1 && !color[g[s][i]][ind]) dfs(g[s][i], ind);
	}
}

int main() {
	fastio;

	int n, m, x, y, z, l = 0, ans = 0;
	cin >> n >> m;
	for (int i = 0; i < m; i++) {
		cin >> x >> y;
		g[x].add(y);
		g[y].add(x);
	}
	for (int i = 1; i <= n; i++) {
		for (int j = 0; j < g[i].size(); j++) {
			z = g[i][j];
			g[i][j] = -1;
			dfs(i, l);
			l++;
			g[i][j] = z;
			if (!color[g[i][j]][l - 1]) ans++;
		}
	}
	cout << ans / 2;
	return 0;
}