#include <bits/stdc++.h>

using namespace std;

vector<bool> was;
vector<vector<int>> arr;
queue<pair<int, int>> start;

void dfs(int now, int no1, int no2) {
    was[now] = true;
    for(int i = 0; i < arr[now].size(); i++) {
        if (!was[arr[now][i]]) {
            if((now == no1 && arr[now][i] == no2) || (now == no2 && arr[now][i] == no1)){
                continue;
            }
            dfs(arr[now][i], no1, no2);
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m, count = 0;
    cin >> n >> m;
    arr.resize(n + 1);
    was.resize(n + 1);
    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        arr[a].push_back(b);
        arr[b].push_back(a);
        start.push({a, b});
    }
    while (!start.empty()) {
        fill(was.begin(), was.end(), false);
        int x = start.front().first, y = start.front().second;
        dfs(1, x, y);
        for(int i = 1; i<n; i++){
            if(!was[i]){
                count++;
                break;
            }
        }
        start.pop();
    }
    cout<<count;
}