#include <bits/stdc++.h>

using namespace std;

void SetIO() {
#ifdef BLAT
    freopen("input.in", "r", stdin);
    freopen("output.out", "w", stdout);
#endif // BLAT
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);
}

const int INF = 2e9;
const int N = 1e5;

unordered_set <int> freq[1 + N];
unordered_map <int, int> mp;
int v[1 + N];
int vv[1 + N];

int main() {
    SetIO();
    int n, k;
    cin >> n;

    for(int i = 1; i <= n; i++) cin >> v[i];
    for(int i = 1; i <= n; i++) {
        k = v[i];
        for(int j = 1; j <= k; j++) {
            int nr;
            cin >> nr;
            freq[i].insert(nr);
        }
    }

    for(int i = 1; i <= n; i++) {
        for(auto it : freq[i]) mp[it]++;
    }

    int ans(INF);
    for(auto it : mp) {
        if(it.second == n) {
            ans = min(ans, it.first);
        }
    }

    if(ans != 2e9) cout << ans;
    else cout << 'x';
    return 0;
}
