#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#define debug(x) cerr << #x << " " << x << "\n"
#define debug_with_space(x) cerr << #x << " " << x << " "

using namespace std;
using namespace __gnu_pbds;
typedef long long ll;
typedef pair <int,int> pii;
typedef tree <int, null_type, less <int>, rb_tree_tag, tree_order_statistics_node_update> OST;

const int NMAX = 1001;
const int p = 31;
const int INF = 2e9;
const int BLOCK = 100;
const int MOD = 1000000007;
const int nr_of_bits = 20;

int n;
vector <int> v[NMAX];
struct ura{
    int first, second;
} edges[2001];
int viz[NMAX];

void DFS(int node, int proh){
    viz[node] = 1;
    for(auto x : v[node]){
        int vec = edges[x].first + edges[x].second - node;
        if(viz[vec] || x == proh)
            continue;
        DFS(vec, proh);
    }
}
int comp = 0;

bool OK(int x){
    int cnt = 0;
    for(int i = 1; i <= n; i++)
        viz[i] = 0;
    for(int i = 1; i <= n; i++){
        if(!viz[i]){
            cnt++;
            DFS(i, x);
        }
    }
    if(x == 0)
        comp = cnt;
    return (cnt > comp);
}


int main(){

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int i;
    int m;
    cin >> n >> m;
    for(i = 1; i <= m; i++){
        cin >> edges[i].first >> edges[i].second;
        v[edges[i].first].push_back(i);
        v[edges[i].second].push_back(i);
    }
    int sol = 0;
    OK(0);
    for(i = 1; i <= m; i++){
        if(OK(i)){
            sol++;
        }
    }
    cout << sol;
}
