#include <iostream>
#include <vector>

using namespace std;

const int NMAX = 600;
const int MMAX = 2000;
int a[MMAX + 1], b[MMAX + 1];
bool viz[NMAX + 1];
vector <int> v[NMAX + 1];

int cnt, ban_nod, ban_next_nod;

void dfs( int nod ){
  viz[nod] = 1;
  for( int i = 0; i < v[nod].size(); ++i )
    if( !viz[v[nod][i]]  ){
      if( nod == ban_nod ){
        if( v[nod][i] != ban_next_nod )
          dfs(v[nod][i]);
      }
      else if( v[nod][i] == ban_nod ){
        if( nod != ban_next_nod )
          dfs(v[nod][i]);
      }
      else dfs(v[nod][i]);
    }
}

int main() {
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  cout.tie(0);
  int n, m, i, j, sol;
  cin >> n >> m;
  for( i = 0; i < m; ++i ){
    cin >> a[i] >> b[i];
    v[a[i]].push_back(b[i]);
    v[b[i]].push_back(a[i]);
  }
  sol = 0;
  int nr_conex = 0;
  for( i = 1; i <= n; ++i ){
    if( !viz[i] ){
      ++nr_conex;
      dfs(i);
    }
  }
  for( i = 0; i < m; ++i ){
    for( j = 1; j <= n; ++j )
      viz[j] = 0;
    ban_nod = a[i];
    ban_next_nod = b[i];
    cnt = 0;
    for( j = 1; j <= n; ++j ){
      if( !viz[j] ){
        dfs(j);
        ++cnt;
      }
    }
    if( cnt > nr_conex )
      ++sol;
  }
  cout << sol;
  return 0;
}
