﻿#include <iostream>
#include <vector>
#include <algorithm>
#include <numeric>
#include <functional>

#include <map>


int n, size[1005];
std::map<int, int> map;


int32_t main() {
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(0);
	std::cout.tie(0);

	std::cin >> n;
	for (int i = 0; i < n; i++) {
		std::cin >> size[i];
	}
	for (int i = 0; i < n; i++) {
		std::vector<int> vec(size[i]);
		for (int j = 0; j < size[i]; j++) {
			std::cin >> vec[j];
		}
		std::sort(vec.begin(), vec.end());
		vec.resize(std::unique(vec.begin(), vec.end()) - vec.begin());
		for (auto it = map.begin(); it != map.end(); ) {
			if (it->second != i) {
				auto it2 = std::next(it);
				map.erase(it);
				it = it2;
			} else {
				it++;
			}
		}
		for (const auto &it : vec) {
			map[it]++;
		}
	}

	for (const auto &it : map) {
		if (it.second == n) {
			std::cout << it.first << std::endl;
			return 0;
		}
	}
	std::cout << "x\n";


	std::cout.flush();
	return 0;
}