#include <iostream>
#include <deque>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
using namespace std;
vector <vector <int> > graph;
vector <int> tin;
vector <int> tout;
int time = 0;
vector <int> used;
vector <int> up;
int ans = 0;
void dfs(int v, int p) {
    used[v] = 1;
    up[v] = time;
    tin[v] = time;
    time++;
    for (int i = 0; i < graph[v].size(); ++i) {
        if (graph[v][i] == p) {
            continue;
        }
        if (used[graph[v][i]]) {
            up[v] = min(up[graph[v][i]], up[v]);
        }
        else {
            dfs(graph[v][i], v);
            up[v] = min(up[v], up[graph[v][i]]);
            if (up[graph[v][i]] >= tin[graph[v][i]]) {
                ans++;
            }
        }
    }
}
signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n, m;
    cin >> n >> m;
    graph.resize(n);
    tin.resize(n);
    tout.resize(n);
    used.resize(n);
    up.resize(n);
    for (int i = 0; i < m; ++i) {
        int v1, v2;
        cin >> v1 >> v2;
        v1--;
        v2--;
        graph[v1].push_back(v2);
        graph[v2].push_back(v1);
    }
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            dfs(i,-1);
        }
    }
    cout << ans;
    
}       