#pragma GCC optimize("Ofast")

#define pii pair < int, int >
#include <bits/stdc++.h>
#define ld long double
#define ll long long
#define _ << ' ' <<
#define se second
#define fi first
//#define int ll

using namespace std;

const int N = 2e5 + 100;
const int inf = 2e9 + 100;
const int mod = 1e9 + 7;

ll bin_pow(ll x, ll os) {
    if(os == 1) return x % mod;
    if(os % 2) return ((x % mod) * (bin_pow(x, os - 1)) % mod) % mod;

    int res = bin_pow(x, os / 2) % mod;
    return (res * res) % mod;
}

vector < vector < int > > g(N);
vector < vector < int > > gr(N);
vector < bool > used(600, false);

pair < int, int > now;

void DFS(int v) {
    used[v] = true;
    for(int to : gr[v]) {
        if(!used[to])
            DFS(to);
    }
}

int32_t main()
{
    #ifdef STRIKAZA
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif

    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    int n, m;
    cin >> n >> m;
    vector < pii > edges;
    for(int i = 1; i <= m; i++) {
        int x, y;
        cin >> x >> y;
        g[x].push_back(y);
        g[y].push_back(x);
        edges.push_back({ x, y });
    }

    int ans = 0;
    for(auto i : edges) {
        now = i;
        used.clear(); used.resize(600, false);
        for(int i = 1; i <= n; i++) {
            gr[i].clear();
        }
        for(auto j : edges) {
            if(j.fi == i.fi && j.se == i.se) continue;
            gr[j.fi].push_back(j.se);
            gr[j.se].push_back(j.fi);
        }

        DFS(1);

        for(int j = 1; j <= n; j++) {
            if(!used[j]) {
                ans++; break;
            }
        }
    }

    cout << ans << endl;
    return 0;
}
