#include <iostream>
#include <vector>
#include <bitset>
using namespace std;
const int maxn = 650;
vector < int > v[maxn];
bitset < maxn > bs;
int ans, t[maxn], low[maxn];
void dfs(int x, int p) {
    bs[x] = 1;
    low[x] = t[x] = t[p]+1;
    for (int i : v[x]) {
        if (i == p) continue;
        if (bs[i]) {
            low[x] = min(low[x], t[i]);
        } else {
            dfs(i, x);
            low[x] = min(low[x], low[i]);
            if (low[i] > t[x])
                ++ans;
        }
    }
} 
int n, m, x, y;
int main () {
    ios_base :: sync_with_stdio(0);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cin >> n >> m;
    for (int i = 0 ; i < m ; ++i) {
        cin >> x >> y;
        v[x].push_back(y);
        v[y].push_back(x);
    }
    for (int i = 1 ; i <= n ; ++i)
        if (!bs[i]) dfs(i, 0);
    cout << ans << '\n';
    return 0;
}