#include <iostream>
#include <vector>
#include <string.h>
using namespace std;
#define endl '\n'
#define int long long
#define MAXN 605
int br, edges;
vector<int> graph[MAXN];
vector<pair<int, int> > v;
int block1, block2;
int way;
int u[MAXN];
void dfs(int v){
    u[v] = way;
    for(int att : graph[v]){
        if(u[att] == way) continue;
        if((v == block1 && att == block2) || (v == block2 && att == block1)) continue;
        dfs(att);
    }
}
signed main(){
    cin.tie(0); ios::sync_with_stdio(false);
    cin >> br >> edges;
    for(int i = 0; i < edges; ++i){
        int from, to; cin >> from >> to;
        graph[from].push_back(to);
        graph[to].push_back(from);
        v.push_back({from, to});
    }
    int result = 0;
    for(pair<int, int> p : v){
        int from = p.first, to = p.second;
        block1 = from; block2 = to;
        ++way;
        dfs(from);
        if(u[to] != way) ++result;
    }
    cout << result << endl;
    return 0;
}